MAX     EQU     31                                         
U       EQU     64                                         
KEZDO   EQU     0B001H                                     
FAZIS   DB      00                                         
SPTAR   DW      0000                                       
HONNAN  DW      0000                                       
HOVA    DW      0000                                       
;********************                                      
START   LD      IY,0000                                    
        DI                                                 
        LD      A,50H                                      
        OUT     (2),A                                      
        LD      (3),A                                      
        EI                                                 
        LD      B,00                                       
CCC     PUSH    BC                                         
        LD      B,MAX                                      
FOCIKL  PUSH    BC                                         
        CALL    HELY                                       
        LD      HL,HELY+2                                  
        INC     (HL)            ;KOVETKEZOT RAKJA KI       
        POP     BC                                         
        DJNZ    FOCIKL                                     
        XOR     A                                          
        LD      (HELY+2),A      ;IY+0-TOL                  
        LD      HL,(K+1)                                   
        DEC     HL                                         
        LD      (K+1),HL        ;1 BYTE-TAL BALRA LEPUNK   
        LD      B,MAX                                      
FOCIKL2 PUSH    BC                                         
        CALL    HELY                                       
        LD      HL,HELY+2                                  
        INC     (HL)            ;KOVETKEZO KARAKTERT RAKJA 
        POP     BC                                         
        DJNZ    FOCIKL2                                    
        XOR     A                                          
        LD      (HELY+2),A      ;IY+00-TOL                 
        INC     IY              ;SZOVEGBN IS LEPUNK        
        LD      HL,(K+1)                                   
        INC     HL                                         
        LD      (K+1),HL                                   
        LD      HL,KAR1+2                                  
        LD      DE,KAR1                                    
        LD      BC,MAX*2-2      ;KAR1 SZAM-1)*2            
        LDIR                                               
;       DEC     HL                                         
;       DEC     HL                                         
;       LD      DE,0B22DH                                  
;       LD      (HL),E                                     
;       INC     HL                                         
;       LD      (HL),D                                     
        LD      IX,0B00FH                                  
        CALL    TOROL                                      
VEGE    POP     BC                                         
        DJNZ    CCC                                        
        RET                                                
KIRAK   LD      A,20                                       
        LD      HL,(HONNAN)                                
        LD      DE,(HOVA)                                  
CIKLUS2 LD      BC,64                                      
        LDI                                                
        LDI                                                
        EX      DE,HL                                      
        ADD     HL,BC                                      
        EX      DE,HL                                      
        DEC     A                                          
        JR      NZ,CIKLUS2                                 
        RET                                                
TOROL   DI                                                 
        LD      BC,0002                                    
        ADD     IX,BC                                      
        LD      (SPTAR),SP                                 
        LD      SP,IX                                      
        LD      HL,0000                                    
        ADD     HL,SP                                      
        LD      DE,0000H                                   
        LD      B,20                                       
CIKLUS  PUSH    DE              ;2 BYTE                    
        LD      A,64                                       
        ADD     A,L                                        
        JR      NC,NINCS                                   
        INC     H                                          
NINCS   LD      L,A                                        
        LD      SP,HL                                      
        DJNZ    CIKLUS                                     
        LD      SP,(SPTAR)                                 
        EI                                                 
        RET                                                
SINUS   PUSH    HL              ;EZ NEM VALTOZHAT          
        LD      HL,SINTAB                                  
        LD      A,(HELY+2)                                 
        ADD     A,A                                        
        ADD     A,L                                        
        JR      NC,NINCS3                                  
        INC     H                                          
NINCS3  LD      L,A                                        
        LD      E,(HL)                                     
        INC     HL                                         
        LD      D,(HL)                                     
        POP     HL                                         
        RET                                                
;**************************************                    
;EZ A RUTIN MGJELENITI AZ (IY+0) KARAKTERT A K+1 SZERINTI  
;HELYEN                                                    
;**************************************                    
HELY    LD      A,(IY+0)                                   
        SUB     32                                         
        LD      L,A                                        
        LD      H,0             ;HL=A                      
        ADD     HL,HL                                      
        ADD     HL,HL                                      
        ADD     HL,HL           ;HL=HL*8                   
        LD      B,H                                        
        LD      C,L                                        
        ADD     HL,HL                                      
        ADD     HL,HL                                      
        ADD     HL,BC           ;HL=40*A                   
        LD      DE,TAR                                     
        ADD     HL,DE                                      
        LD      (HONNAN),HL                                
        LD      A,(HELY+2)                                 
;       ADD     A,8             ;..OSZLOPTOL KEZDJUK       
        ADD     A,A             ;2 BYTE-ONKENT LEPUNK      
K       LD      HL,KEZDO                                   
        ADD     A,L                                        
        JR      NC,NINCS1                                  
        INC     H                                          
NINCS1  LD      L,A                                        
        CALL    SINUS           ;KI:DE-KITERES,HL-MARAD    
        ADD     HL,DE                                      
        LD      (HOVA),HL                                  
        LD      A,(HELY+2)                                 
        ADD     A,A                                        
        LD      HL,KAR1                                    
        ADD     A,L                                        
        JR      NC,NINCS2                                  
        INC     H                                          
NINCS2  LD      L,A             ;HL-KARAKTERTABLARA MUTAT  
        PUSH    HL                                         
        LD      E,(HL)                                     
        INC     HL                                         
        LD      D,(HL)                                     
        PUSH    DE                                         
        POP     IX                                         
        CALL    TOROL                                      
        POP     HL                                         
        LD      DE,(HOVA)                                  
        LD      (HL),E                                     
        INC     HL                                         
        LD      (HL),D                                     
        CALL    KIRAK                                      
        RET                                                
SINTAB  DW      0,4*U,8*U,11*U,14*U,16*U,18*U,19*U,20*U    
S2      DW      20*U,19*U,18*U,16*U,14*U,11*U,8*U,4*U,0    
S3      DW      -4*U,-8*U,-11*U,-14*U,-16*U,-18*U,-19*U    
S4      DW      -20*U,-20*U,-19*U,-18*U,-16*U,-14*U,-11*U  
S5      DW      -8*U,-4*U,0                                
ST      LD      IX,TAR                                     
        LD      A,32-1                                     
        LD      (FAZIS),A                                  
LOOP    LD      BC,0101H                                   
        RST     30H,03                                     
        LD      A,(FAZIS)                                  
        CP      159                                        
        JR      Z,VEG                                      
        INC     A                                          
        LD      (FAZIS),A                                  
        LD      C,A                                        
        RST     30H,01                                     
        CALL    NAGYIT                                     
        JR      LOOP                                       
VEG     XOR     A                                          
        LD      (FAZIS),A                                  
        RET                                                
NAGYIT  DI                                                 
        LD      A,50H                                      
        OUT     (2),A                                      
        LD      (3),A                                      
        EI                                                 
        LD      HL,8000H                                   
        LD      B,10                                       
CIKL1   LD      A,(HL)                                     
        PUSH    BC                                         
        LD      B,8                                        
CIKL    RLCA                                               
        JR      C,ONE                                      
        SLA     E                                          
        RL      D                                          
        SLA     E                                          
        RL      D               ;BC<00                    
        DJNZ    CIKL                                       
        JR      VEG                                        
ONE     RL      E                                          
        RL      D                                          
        SCF                                                
        RL      E                                          
        RL      D                                          
        DJNZ    CIKL                                       
VEG     LD      (IX+0),D                                   
        LD      (IX+1),E                                   
        LD      (IX+2),D                                   
        LD      (IX+3),E                                   
        LD      BC,04                                      
        ADD     IX,BC                                      
        LD      BC,64                                      
        ADD     HL,BC                                      
        POP     BC                                         
        DJNZ    CIKL1                                      
        RET                                                
KAR1    DW      45056,45056,45056,45056,45056,45056,45056  
KK1     DW      45056,45056,45056,45056,45056,45056,45056  
KK2     DW      45056,45056,45056,45056,45056,45056,45056  
KK3     DW      45056,45056,45056,45056,45056,45056,45056  
KK4     DW      45056,45056,45056,45056,45056,45056,45056  
TAR     DS      10                                         
                                                                
                                                                
                                                                
                                                                
                                                                
                                                                
                                                                